// Shapefile.cs created with MonoDevelop
// User: jencek at 6:12 14.10.2009
//
// To change standard headers go to Edit->Preferences->Coding->Standard Headers
//

using System;
using System.IO;

namespace ReadShapefile
{
	
	//Converts firts 10 points from point ESRI shapefile to CSV file.
	public class ShapeFile
	{
		
		public ShapeFile()
		{
			
		}
		public void readPointFile(String name) {
			
		}
		//Converts firts 10 points from point ESRI shapefile to CSV file.
		public void convertToCSV(String input, String output) {
			FileStream fs = new FileStream(input, FileMode.Open);
			BinaryReader br = new BinaryReader(fs); //Use binary reader. ESRI Shapefile is binary written.
			FileStream fsout = new FileStream(output, FileMode.Create); //File where to store output
			StreamWriter sw = new StreamWriter(fsout);
			//This is a header, we can skip it
			br.ReadInt32(); //file code
			for(int i=0; i<6; i++) {
			   br.ReadInt32(); //reserverd bytes
		    }
			br.ReadInt32(); //version
			br.ReadInt32(); //type
			br.ReadDouble(); //xmin
			br.ReadDouble(); //ymin
			br.ReadDouble(); //xmax
			br.ReadDouble(); //ymax 
			br.ReadDouble(); //zmin
			br.ReadDouble(); //zmax
			br.ReadDouble(); //mmin
			br.ReadDouble(); //mmax
			//Here is the end of the header
			try {
			   //loop vid first 10 points
                for (int j=0; j<10; j++) {
                  br.ReadInt32(); //point id
				  br.ReadInt32(); //record length
				  br.ReadInt32(); //feature type - point
				  sw.WriteLine(br.ReadDouble() + ";" + br.ReadDouble());	//X and Y coordinates
			   }
             }
             catch (EndOfStreamException ex) {}
             finally {
                  br.Close();
		          sw.Close();
             }
		}
	}
}
